Lua_CollectWindow = class("Lua_CollectWindow", Lua_Window);
function Lua_CollectWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CollectWindow";
	self.skinName = "CollectWindow_skin";
	self.blackAlpha = 0.5;
	self.showClose = false;
	self.showBlackMask = false;
	self.setHasBlackMask = false;
end

function Lua_CollectWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.collect_bg2.type = UIBasicSprite.Type.Filled;
	self.collect_bg2.fillDirection = UIBasicSprite.FillDirection.Radial360;
	self.collect_bg2.fillAmount = 0;
end

function Lua_CollectWindow:showWin(param)
	self.data = tonumber(tostring(param));

	-- self.ProgressBar:setMaxValue(self.leftTime * 100);
	-- self.ProgressBar:setText("");
	self.collect_bg2.fillAmount = 0;
	
	self.startTime = getTime();
	self.leftTime = self:getCollectTime(self.data);
	self:startTimer();
end

-- 获取采集时间
function Lua_CollectWindow:getCollectTime(targetId)
	local result = 5;
	local monster = ThingUtil.instance:getThingById(targetId);
	if monster ~= nil and monster.data ~= nil then
		local objId = tonumber(monster.data.objId);
		local obj = getConfig({ "monster", objId });
		if obj ~= nil and obj.collect_time ~= nil then
			result = tonumber(obj.collect_time) * 0.001;
		end
	else
		local obj = getConfig({ "monster", targetId });
		if obj ~= nil and obj.collect_time ~= nil then
			result = tonumber(obj.collect_time) * 0.001;
		end
	end
	return result;
end

function Lua_CollectWindow:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_CollectWindow", 0.01, self, self.onCountDown);
	end
end

function Lua_CollectWindow:onCountDown()
	if self.startTime ~= nil and self.leftTime ~= nil then
		local lt = getTime() - self.startTime;
		if lt > self.leftTime then
			self:clearTimer();
			MsgUtil.callFunc("END_COLLECT", tostring(self.data));

			-- 夺旗判断
			if DataCenter.campWarData.bInCampWarScene == true and self.monsterType == 2 then
				OperateAlert.show(LanUtil.getValue(122717));
			end
			self:hide();
			
			return;
		end
		-- self.ProgressBar:setValue(lt * 100);
		self.collect_bg2.fillAmount = Mathf.Clamp(lt / self.leftTime, 0, 1);
	else
		self.collect_bg2.fillAmount = 1;
	end
end

function Lua_CollectWindow:clearTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.onCountDown);
	end
end

function Lua_CollectWindow:dispose()
	self:clearTimer();
	
	self:superCall("dispose");
end